module Laws(Equation,CondEq,Theor,scrubCondEq,unletTheor,scrubTheory,scrubth,
            TheorMap) 
where

import List
import Names
import Expressions

type Equation = (Exp,Exp)
type CondEq = (String,[Equation],Equation)
type Theor= [CondEq]
type TheorMap = String -> Maybe Theor

freevarsEq :: Equation -> [VarId]
freevarsEq (e1,e2) = freevars e1 `union` freevars e2

freevarsCeq :: CondEq -> [VarId]
freevarsCeq (n,cs,e) = foldr union [] (map freevarsEq (e:cs))

typevarsEq :: Equation -> [TypeId]
typevarsEq (e1,e2) = typevars e1 `union` typevars e2
typevarsCeq (n,cs,e) = foldr union [] (map typevarsEq (e:cs))

scrubEq :: Equation -> Rename Equation
scrubEq (e1,e2) = do e1' <- scrub e1
                     e2' <- scrub e2
                     return (e1',e2')

scrubCeq :: CondEq -> Rename CondEq
scrubCeq (n,cs,e) = do xs <- mapM newname fvs
                       ts <- mapM newtyp fts
                       cs' <- mapM scrubEq cs
                       e' <- scrubEq e
                       return (n,cs',e')
                    where fvs = freevarsCeq (n,cs,e)
                          fts = typevarsCeq (n,cs,e)

scrubCondEq :: CondEq -> Name CondEq
scrubCondEq  = renaming scrubCeq

scrubTheory :: Theor-> Name Theor
scrubTheory cs = mapM scrubCondEq cs

unletTheor :: Theor -> Theor
unletTheor = map unletCeq

unletCeq :: CondEq -> CondEq
unletCeq (n,es,e) = (n,map unletEq es, unletEq e)

unletEq :: Equation -> Equation
unletEq (e1,e2) = (unlet e1, unlet e2)

scrubth t = evalName supply (scrubTheory (unletTheor t))

