-- Some demos with strips, crops, and swirls

module Strips where

import Monad
import Pan
import Simple (swirlUI)


widthUI :: Label -> UI FloatE
widthUI label = slider label (0, 150) 50

stripUI :: Label -> UI Region
stripUI label = do width <- widthUI label
                   return $ uscale width vstrip

stripSwirlUI = swirlUI `ap` stripUI "strip width"

-- Region if ticked or universal, for cropping/intersection.
regUI :: UI Region -> UI Region
regUI regUI = hbox $
  do reg   <- regUI
     doReg <- tick "crop" True
     return $ ifE doReg reg universeR

intersectionUI :: [UI Region] -> UI Region
intersectionUI uis =
  liftM (foldr intersectR universeR) (sequence uis)


hvdSwirlUI = ap swirlUI $ intersectionUI $ map regUI
             [ stripUI "horizontal crop"
             , liftM (rotate (pi/2)) $ stripUI "vertical crop"
             , liftM disk $ slider "radius" (0,200) 50
             ]

----------------------------------------

makeAll = makeAllFor allBackends

makeAllFor bends = do
  compileImageFor bends "swirl strip"      stripSwirlUI
  compileImageFor bends "swirl crop strip" hvdSwirlUI
