# Common makefile definitions.  Always define PAN_TOP before including

include $(PAN_TOP)/paths.mk

_VC=$(CORSDK)/compiler/VC
_VCBIN=$(_VC)
_VCLIB=$(_VC)
_VCINC=$(_VC)

# (conal) Using separate build

# _VC=$(CORSDK)/compiler/v70comx
# _VCBIN=$(_VC)
# _VCLIB=$(_VC)/lib
# _VCINC=$(_VC)/include

_VB=$(CORSDK)/compiler/VB
_BIN=$(CORSDK)/bin
_BC=$(_VB)/bc.exe
_CL=$(_VCBIN)/cl.exe
_C1=$(_VCBIN)/C1.dll
_CX=$(_VCBIN)/c1xx.dll
_C2=$(_VCBIN)/c2.dll
_ASSEM=$(_BIN)/assem.exe
_TLBIMP=$(_BIN)/tlbimp.exe
_COMREG=$(_BIN)/comreg.exe
_LINK=$(_VCBIN)/link.exe
_DASM=$(_BIN)/ILdasm.exe
_MINFO=$(_BIN)/metainfo.exe
#_LIBS=$(_VCLIB)/mscoree.lib $(_VCLIB)/libc.lib
_LIBS=$(_VCLIB)/msvccee.lib $(_VCLIB)/libc.lib

# Without -c
_CFLAGS_PRE = -com+ -nologo -I$(_VC) -I$(WINSYSDIR) -I$(IHC_DIR)/lib-src
_CFLAGS = $(_CFLAGS_PRE) -c

#_CFLAGS = -com+ -I$(_VC) -I$(WINSYSDIR) -c -B2 $(_C2) -Bx $(_CX) 

_LFLAGS= -nodefaultlib -entry:main -nologo
#_LFLAGS= -nodefaultlib -noentry
#_LFLAGS= -nodefaultlib
_LDFLAGS= -nodefaultlib -dll -noentry -nologo


# Project directories
PAN_IMPORT_DIR=$(PAN_TOP)/import

# HaskellDirect interfacing
#
#   UNIV_IHC_OPTS  - static options that apply to entire project.
#   SRC_IHC_OPTS   - options that apply to one directory / Makefile.
#   $*_IHC_OPTS    - options that apply to a particular file.
#   EXTRA_IHC_OPTS - options to set at make-invocation time.

IHC = $(IHC_DIR)/ihc.exe
#IHC_LIB_DIR=$(IHC_DIR)/lib

IHC_OPTS = $(UNIV_IHC_OPTS) $(SRC_IHC_OPTS) $($*_IHC_OPTS) $(EXTRA_IHC_OPTS) 

# "to avoid making gratuitous passes over the abstract Haskell
# representation that the compiler maintains" (sof)
IHC_OPTS += -fno-export-list -fno-import-lists

# No use for LIBIDs here, so don't emit them.
IHC_OPTS += -fno-library-ids

# To see what's happening
IHC_OPTS += -dshow-passes -v

# In case you're missing more COM+ specific IHC_OPTS; have a look in
# CorSupport/Makefile.

MSCORDLL = $(WINSYSDIR)/mscorlib.dll


# There will be lots of errors of the form
# 
#   autoTypeToHaskellType: unknown auto type
# 
# Sof's comments:
# 
#     passing of GUIDs and other structs as args. This is only
#     supported (but undocumented, afaik) with oleaut32 that comes
#     with later versions of NT4 SPs (starting with 3, I believe). I
#     don't support it, so the compiler just falls back to using
#     overloaded Variant args here - hopefully that will get you by.

GCC = gcc

CL = cl

# Haskell (GHC) compiler options:
#   UNIV_HC_OPTS  - static options that apply to entire project.
#   SRC_HC_OPTS   - options that apply to one directory / Makefile.
#   $*_HC_OPTS    - options that apply to a particular file.
#   EXTRA_HC_OPTS - options to set at make-invocation time.

# Path to the (Glasgow) Haskell compiler to use
HC=ghc

# Is it 4.08(.1)?  YES/NO
USING_GHC_4_08=YES

HC_OPTS = $(UNIV_HC_OPTS) $(SRC_HC_OPTS) $($*_HC_OPTS) $(EXTRA_HC_OPTS) 

# Use Glasgow extensions + Hugs/GHC ext library.
UNIV_HC_OPTS = -fglasgow-exts

DEPEND_OPTS = $(HC_OPTS)

# For construction of static libs for ghc.  Phasing out.
AR = ar clqs
RANLIB = ranlib

# Linker options - used when building HS_PROG
LD_OPTS = $(SRC_LD_OPTS) $($*_LD_OPTS) $(EXTRA_LD_OPTS)

# Files used for make depend.  You might want to add some
DEPEND_SRCS = $(HS_SRCS)

#
# We allow the defaults to be overridden via a build tree local
# .mk file (i.e., it is not stored in the repository.)
#
-include $(PAN_TOP)/local.mk
